/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 *
 * You may not modify, use, reproduce, or distribute this software except in
 * compliance with the terms of the License at:
 * http://developer.sun.com/berkeley_license.html
 */

package com.sun.jmaki.faces.tag;

import javax.faces.component.UIComponent;

/**
 * <p>JSP custom tag for the Dojo Clock component.</p>
 */
public class DojoClockTag extends AbstractComponentTag {
    

    // ------------------------------------------------------ Instance Variables


    private String clockType;
    private String handBorderColor;
    private String handColor;
    private String label;
    private String labelColor;
    private String timeZoneOffset;
    private String topLabelColor;


    // -------------------------------------------------- UIComponentTag Methods


    /**
     * <p>Return the component type required for this tag.</p>
     */
    public String getComponentType() {
        return "com.sun.jmaki.faces.DojoClock";
    }


    /**
     * <p>Return the renderer type required for this tag.</p>
     */
    public String getRendererType() {
        return "com.sun.jmaki.faces.DojoClock";
    }


    /**
     * <p>Release resources allocated for this tag instance.</p>
     */
    public void release() {

        super.release();
        this.clockType = null;
        this.handBorderColor = null;
        this.handColor = null;
        this.label = null;
        this.labelColor = null;
        this.timeZoneOffset = null;
        this.topLabelColor = null;

    }


    /**
     * <p>Set properties for the standard attributes common to all
     * components in this library.</p>
     *
     * @param component UIComponent on which to set properties
     */
    protected void setProperties(UIComponent component) {

        super.setProperties(component);
        setStringProperty(component, "clockType", this.clockType);
        setStringProperty(component, "handBorderColor", this.handBorderColor);
        setStringProperty(component, "handColor", this.handColor);
        setStringProperty(component, "label", this.label);
        setStringProperty(component, "labelColor", this.labelColor);
        setIntegerProperty(component, "timeZoneOffset", this.timeZoneOffset);
        setStringProperty(component, "topLabelColor", this.topLabelColor);

    }
    

    // ------------------------------------------------------- Attribute Setters

    public void setClockType(String clockType) {
        this.clockType = clockType;
    }

    public void setHandBorderColor(String handBorderColor) {
        this.handBorderColor = handBorderColor;
    }

    public void setHandColor(String handColor) {
        this.handColor = handColor;
    }

    public void setLabel(String label) {
        this.label = label;
    }

    public void setLabelColor(String labelColor) {
        this.labelColor = labelColor;
    }

    public void setTimeZoneOffset(String timeZoneOffset) {
        this.timeZoneOffset = timeZoneOffset;
    }

    public void setTopLabelColor(String topLabelColor) {
        this.topLabelColor = topLabelColor;
    }

}
