/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 *
 * You may not modify, use, reproduce, or distribute this software except in
 * compliance with the terms of the License at:
 * http://developer.sun.com/berkeley_license.html
 */

package com.sun.jmaki.faces.tag;

import javax.faces.component.UIComponent;

/**
 * <p>JSP custom tag for the Flickr Word component.</p>
 */
public class FlickrWordTag extends AbstractValueHolderComponentTag {
    

    // ------------------------------------------------------ Instance Variables


    private String apiKey;
    private String size;
    private String unique;


    // -------------------------------------------------- UIComponentTag Methods


    /**
     * <p>Return the component type required for this tag.</p>
     */
    public String getComponentType() {
        return "com.sun.jmaki.faces.FlickrWord";
    }


    /**
     * <p>Return the renderer type required for this tag.</p>
     */
    public String getRendererType() {
        return "com.sun.jmaki.faces.FlickrWord";
    }


    /**
     * <p>Release resources allocated for this tag instance.</p>
     */
    public void release() {

        super.release();
        this.apiKey = null;
        this.size = null;
        this.unique = null;

    }


    /**
     * <p>Set properties for the standard attributes common to all
     * components in this library.</p>
     *
     * @param component UIComponent on which to set properties
     */
    protected void setProperties(UIComponent component) {

        super.setProperties(component);
        setStringProperty(component, "apiKey", this.apiKey);
        setIntegerProperty(component, "size", this.size);
        setBooleanProperty(component, "unique", this.unique);

    }
    

    // ------------------------------------------------------- Attribute Setters

    public void setApiKey(String apiKey) {
        this.apiKey = apiKey;
    }

    public void setSize(String size) {
        this.size = size;
    }

    public void setUnique(String unique) {
        this.unique = unique;
    }

}
