/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 *
 * You may not modify, use, reproduce, or distribute this software except in
 * compliance with the terms of the License at:
 * http://developer.sun.com/berkeley_license.html
 */

package com.sun.jmaki.faces.tag;

import javax.faces.component.UIComponent;

/**
 * <p>JSP custom tag for the Yahoo Tabbed View component.</p>
 */
public class YahooTabbedViewTag extends AbstractComponentTag {


    // ------------------------------------------------------ Instance Variables


    private String current = null;


    // -------------------------------------------------- UIComponentTag Methods


    /**
     * <p>Return the component type required for this tag.</p>
     */
    public String getComponentType() {
        return "com.sun.jmaki.faces.YahooTabbedView";
    }


    /**
     * <p>Return the renderer type required for this tag.</p>
     */
    public String getRendererType() {
        return "com.sun.jmaki.faces.YahooTabbedView";
    }


    /**
     * <p>Release resources allocated for this tag instance.</p>
     */
    public void release() {

        super.release();
        this.current = null;

    }


    /**
     * <p>Set properties for the standard attributes common to all
     * components in this library.</p>
     *
     * @param component UIComponent on which to set properties
     */
    protected void setProperties(UIComponent component) {

        super.setProperties(component);
        setIntegerProperty(component, "current", this.current);

    }
    

    // ------------------------------------------------------- Attribute Setters


    public void setCurrent(String current) {
        this.current = current;
    }


}
