/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 *
 * You may not modify, use, reproduce, or distribute this software except in
 * compliance with the terms of the License at:
 * http://developer.sun.com/berkeley_license.html
 */

package com.sun.jmaki.faces.tag;

import javax.faces.component.UIComponent;

/**
 * <p>JSP custom tag for the Yahoo Tree View Node component.</p>
 */
public class YahooTreeViewNodeTag extends AbstractValueHolderComponentTag {
    

    // ------------------------------------------------------ Instance Variables

    private String contentStyle;
    private String expanded;
    private String href;
    private String labelStyle;
    private String multiExpand;
    private String target;

    // -------------------------------------------------- UIComponentTag Methods


    /**
     * <p>Return the component type required for this tag.</p>
     */
    public String getComponentType() {
        return "com.sun.jmaki.faces.YahooTreeViewNode";
    }


    /**
     * <p>Return the renderer type required for this tag.</p>
     */
    public String getRendererType() {
        return null;
    }


    /**
     * <p>Release resources allocated for this tag instance.</p>
     */
    public void release() {

        super.release();
        this.contentStyle = null;
        this.expanded = null;
        this.href = null;
        this.labelStyle = null;
        this.multiExpand = null;
        this.target = null;

    }


    /**
     * <p>Set properties for the standard attributes common to all
     * components in this library.</p>
     *
     * @param component UIComponent on which to set properties
     */
    protected void setProperties(UIComponent component) {

        super.setProperties(component);
        setStringProperty(component, "contentStyle", this.contentStyle);
        setBooleanProperty(component, "expanded", this.expanded);
        setStringProperty(component, "href", this.href);
        setStringProperty(component, "labelStyle", this.labelStyle);
        setBooleanProperty(component, "multiExpand", this.multiExpand);
        setStringProperty(component, "target", this.target);

    }
    

    // ------------------------------------------------------- Attribute Setters


    public void setContentStyle(String contentStyle) {
        this.contentStyle = contentStyle;
    }

    public void setExpanded(String expanded) {
        this.expanded = expanded;
    }

    public void setHref(String href) {
        this.href = href;
    }

    public void setLabelStyle(String labelStyle) {
        this.labelStyle = labelStyle;
    }

    public void setMultiExpand(String multiExpand) {
        this.multiExpand = multiExpand;
    }

    public void setTarget(String target) {
        this.target = target;
    }


}
