/*
 * Copyright 2007 Sun Microsystems, Inc.  All rights reserved.
 *
 * You may not modify, use, reproduce, or distribute this software except in
 * compliance with the terms of the License at:
 * http://developer.sun.com/berkeley_license.html
 */

package com.sun.jmaki.faces.tag;

import javax.faces.component.UIComponent;

/**
 * <p>JSP custom tag for the Yahoo Tree View component.</p>
 */
public class YahooTreeViewTag extends AbstractValueHolderComponentTag {


    // ------------------------------------------------------ Instance Variables


    private String collapseAnim = null;
    private String expandAnim = null;
    private String expanded = null;


    // -------------------------------------------------- UIComponentTag Methods


    /**
     * <p>Return the component type required for this tag.</p>
     */
    public String getComponentType() {
        return "com.sun.jmaki.faces.YahooTreeView";
    }


    /**
     * <p>Return the renderer type required for this tag.</p>
     */
    public String getRendererType() {
        return "com.sun.jmaki.faces.YahooTreeView";
    }


    /**
     * <p>Release resources allocated for this tag instance.</p>
     */
    public void release() {

        super.release();
        this.collapseAnim = null;
        this.expandAnim = null;
        this.expanded = null;

    }


    /**
     * <p>Set properties for the standard attributes common to all
     * components in this library.</p>
     *
     * @param component UIComponent on which to set properties
     */
    protected void setProperties(UIComponent component) {

        super.setProperties(component);
        setStringProperty(component, "collapseAnim", this.collapseAnim);
        setStringProperty(component, "expandAnim", this.expandAnim);
        setBooleanProperty(component, "expanded", this.expanded);

    }
    

    // ------------------------------------------------------- Attribute Setters


    public void setCollapseAnim(String collapseAnim) {
        this.collapseAnim = collapseAnim;
    }

    public void setExpandAnim(String expandAnim) {
        this.expandAnim = expandAnim;
    }

    public void setExpanded(String expanded) {
        this.expanded = expanded;
    }

}
