jmaki.namespace("jmaki.listeners");
          
jmaki.listeners.mapLocation = function(loc) {
       var location = "location="+ loc + ",ca";
       dojo.io.bind({
           url: jmaki.xhp + "?key=yahoogeocoder&urlparams=" + encodeURIComponent(location),
           method: "get",
           mimetype: "text/json",
           load : function(type, data) {
               jmaki.publish("/jmaki/plotmap", data.coordinates);
           }
       });
}
// add listerner mapping for geocoder
jmaki.addGlueListener("/jmaki/mapLocation", "jmaki.listeners.mapLocation");

jmaki.namespace("jmaki.filters");

// convert an rss feed to the jMaki table format
jmaki.filters.clTableFilter = function(input) {
    var _columns = [
            {title: 'Title'},
            {title: 'City'},            
            {title: 'Price'}
            ];
    var _rows = [];
    // parse each title to get the name, city, and price
    // title contains description (city / district | neighborhood) $00000    
    for (var _i=0; _i < input.channel.items.length;_i++) {
      var _link = input.channel.items[_i].link;      
      var _title = input.channel.items[_i].title;
      var _name = "";
      var cityStart = _title.lastIndexOf("(");
      if (cityStart != -1) _name = _title.substring(0, cityStart);
      var cityEnd = _title.indexOf(")", cityStart);
      var _city = "";
      if (cityStart != -1 && cityEnd != -1) {
          _city = _title.substring(cityStart + 1, cityEnd);
          // get rid of downtown north south east and west
          _city = _city.replace("downtown", "").replace("north", "");
          _city = _city.replace("south", "").replace("east", "");
          _city = _city.replace("west", "");
          // only go for the city when district is mentioned
          if (_city.indexOf("/") != -1) _city = _city.substring(0, _city.indexOf("/") -1);
      }
      // create a link that will publish and event to map the city
      var _cityLink = "<a href=\"javascript:jmaki.publish('/jmaki/mapLocation','" +
                _city + "');\">" + _city + "</a>";
      var _nameLink = "<a href=\"" + _link + "\" target=\"external\">" + _name + "</a>";                
      var _date = input.channel.items[_i].date;
      var _price = /\$[0-9]*/.exec(_title);
      var row = [
         _nameLink,
         _cityLink,
         _price
      ];
      _rows.push(row);
    }
    return {columns : _columns, rows : _rows};
}