package jmaki.runtime.config;

import java.util.Iterator;
import java.util.Map;
import java.util.List;

public class ConfigImpl implements Config {
    
    private Map globalApiKeys;
    private Map widgetApiKeys;
    private Type type;
    
    public ConfigImpl(Type type, Map globalApiKeys, Map widgetApiKeys) {
        this.type=type;
        this.globalApiKeys=globalApiKeys;
        this.widgetApiKeys=widgetApiKeys;
    }
    
    public Iterator getLibs() { return (type == null) || type.getLibs()==null ? GlobalConfig.NULLITERATOR : type.getLibs().listIterator(); }
    public String getPostLoad() { return type==null ? null : type.getPostLoad(); }
    public String getPreLoad() { return type==null ? null  : type.getPreLoad(); }
    public Iterator getStyles() { return (type == null) || type.getStyles()==null ? GlobalConfig.NULLITERATOR : type.getStyles().listIterator(); }
    
    public Iterator getApiKeys() {
        String apiKeyType = null;
        List apiKeyList = null;
        return ((apiKeyType = type.getApiKeyType()) == null
                || ((widgetApiKeys==null || (apiKeyList = (List)widgetApiKeys.get(apiKeyType))==null)
                && (globalApiKeys == null || (apiKeyList=(List)globalApiKeys.get(apiKeyType))== null))) ?
                    GlobalConfig.NULLITERATOR
                : apiKeyList.listIterator();
    }
}