/* Copyright 2005 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: http://developer.sun.com/berkeley_license.html
 */

/**
 * Completion-capable JSF AJAX Wrapper.
 */
package jmaki.runtime.jsf;

import javax.faces.context.FacesContext;
import javax.faces.component.*;

/**
 *
 *
 * @author Greg Murray
 * @author Ed Burns <Ed.Burns@Sun.COM>
 *
*/
public class AjaxWrapper extends UIInput {


    private boolean fromWeb = true;
    private String name = null;
    private String style = null;
    private String script = null;
    private String template = null;
    private String service = null;
    private String selected = null;
    private String args = null;
    private String onload = null;
    private String values = null;
    
    public void setName(String name) {this.name=name;};
    public String getName(){return name;};
    public String getValues() {return values;};
    public void setValues(String values) {this.values=values;};
    public void setService(String service) {this.service=service;};
    public String getService() {return service;};
    public void setStyle(String style) {this.style=style;};
    public String getStyle() {return style;};
    public void setScript(String script) {this.script=script;};
    public String getScript(){return script;};
    public void setTemplate(String template) {this.template=template;};
    public String getTemplate(){return template;};
    public void setSelected(String selected) {this.selected=selected;};
    public String getSelected(){return selected;};
    public String getArgs(){return args;};
    public void setArgs(String args){this.args = args;};
    public AjaxWrapper() {
        super();
        setRendererType("WidgetWrapper");
    }
    
    public String getFamily() {
        return ("WidgetWrapper");
    }
    
    public boolean getRendersChildren() {
        return (true);
    }
    
    public void processDecodes(FacesContext context) {
        // Process this component itself
        try {
            decode(context);
        } catch (RuntimeException e) {
            context.renderResponse();
            throw e;
        }
    }
    
    public void restoreState(FacesContext context, Object stateObj) {
        Object [] state = (Object []) stateObj;
        super.restoreState(context, state[0]);
        setArgs((String) state[1]);
        setName((String) state[8]);
        setScript((String) state[10]);
        setStyle((String) state[11]);
        setTemplate((String) state[12]);
        setSelected((String) state[13]);
        
    }
    
    public Object saveState(FacesContext context) {
        Object state[] = new Object[14];
        
        state[0] = super.saveState(context);
        state[1] = getArgs();
        state[8] = getName();
        state[10] = getScript();
        state[11] = getStyle();
        state[12] = getTemplate();
        state[13] = getSelected();
        return state;
    }
}