<?php
/*
 * jMaki.php
 *
 * Version .8.2.4
 *
 * Author: Greg Murray
 */
//session_start();
require_once 'Json.php';
$uuid;
if (!isset($_SESSION['uuid']))$_SESSION['uuid'] = 1;
else  $_SESSION['uuid'] =  $_SESSION['uuid'] + 1;
$uuid = $_SESSION['uuid'];

// find the resources dir
$scriptName = $_SERVER["SCRIPT_NAME"];
$requestURI;
if (isset($_SERVER['REQUEST_URI'])) {
	$requestURI = $_SERVER['REQUEST_URI'];
} elseif (isset($_SERVER['HTTP_X_REWRITE_URL'])) {
	$requestURI = $_SERVER['HTTP_X_REWRITE_URL'];
} elseif (isset($_SERVER['ORIG_PATH_INFO'])) {
	$requestURI = $_SERVER['ORIG_PATH_INFO'];
} elseif (isset($_ENV['SCRIPT_NAME'])) {
	$requestURI = $_ENV['SCRIPT_NAME'];
} else {
	echo "Failed to find the request URI. This is needed to run jMaki";
}
$count = sizeof(explode("/", $scriptName));
// get the webRoot and widgetDir
$serverName = $_SERVER["HTTP_HOST"];
$serverPort = $_SERVER["SERVER_PORT"];
$contextRoot = "http://" . $serverName;
$resourceDir = "resources/";

if ($serverPort != 80) {
	$contextRoot = $contextRoot . ":" . $serverPort;
}

$serverRoot = $contextRoot;

if (!file_exists("resources")) {
	$rr = "resources/";
	$requestToks = explode("/", $requestURI);
	// pop off the file name
	array_pop($requestToks);
	for($i = 0;$i < sizeof($count); $i++) {	
		$rr = "../" . $rr;
		// pop one level off of the request URI every step back
		array_pop($requestToks);
    	if (file_exists($rr)) {
    		$resourceDir = $rr;
			break;
		} 
	}
	if (!file_exists($rr)) {
		echo "Failed to find the resources directory!";
	} else {
		$contextRoot = $contextRoot . implode("/", $requestToks);
	}
} else {
	$requestURI = $_SERVER["REQUEST_URI"];
	$last = strlen($requestURI) - 1;
	if ($requestURI[$last] != "/") {
		// check if we are a directory request
		$requestToks = array();
		$requestToks = explode("/", $requestURI);
		// remove the file name from the end
		array_pop($requestToks);
		$requestURI = implode("/", $requestToks);
	} else {
		// we need to chop off the last character
		$chars = str_split($requestURI);
		array_pop($chars);
		$requestURI = implode("", $chars);
	}
	$contextRoot = $serverRoot . $requestURI;
}

// get the current working web URI
$requestToks = explode("/", $requestURI);
// do not pop off the end if this is the context root
if (sizeof($requestToks) > 2) array_pop($requestToks);
$currentURI = $serverRoot . implode("/", $requestToks) . '/';	

// array of all types renderered : TODO this should be a map
$types = array();
$pagelibs = array();
$pagestyles = array();

// write out the jmaki script and friends
echo "<script type='text/javascript' src='" .  $contextRoot . "/resources/jmaki.js'></script>\n";
echo "<script type='text/javascript'>jmaki.webRoot='" . $contextRoot . "'; jmaki.resourcesRoot ='/resources'; jmaki.xhp='" . $contextRoot . "/XmlHttpProxy.php';</script>\n";

// save the config into session as we can't trust the globals to be on
//if (!isset($_SESSION['config'])) {
	if (file_exists($resourceDir. 'config.json')) {
		$jsons = new Services_JSON();
		$config = file_get_contents($resourceDir .'config.json');
		$json = $jsons->decode($config );
		$_SESSION['config'] = $json;
	}
//} else {
//    // TODO: Check the time stamp on the file
//	$json = $_SESSION['config'];
//}

function addWidget($name) {
	global $json, $contextRoot, $types, $pagelibs,
		   $pagestyles, $resourceDir, $currentURI, $widgetPath;
	$args = null;
	$service = null;
	$value = null;
	$id = null;
	$typeArgs = null;

	// this is a way around function overloading
	if (func_num_args()  > 1 ){
		$service = func_get_arg(1);
       if ($service != null) {
		    // use the current directory if not starting with /
		    if ($service[0] != "/") {
	            $service = $currentURI . $service;
		    } else {
			    $service = $contextRoot . "/" . $service;
	        }
       }
    }
    if (func_num_args()  > 2) {
	    $args = func_get_arg(2);
	}
	if (func_num_args()  > 3) {
	    $value = func_get_arg(3);
	}
	if (func_num_args()  > 4) {
	    $id = func_get_arg(4);
	}
	if (func_num_args()  > 5) {
	    $typeArgs = func_get_arg(5);
	}

    $type = null;

	if ($id == null) {
		$uuid =  generateUUID($name);
	} else {
		$uuid = $id;
	}
    
     $widgetPath = preg_replace('/\./', '/', $name);
     $widgetDir = $contextRoot . '/resources/' . $widgetPath;
    
    if ($typeArgs == null) {
     	writeType($type, $name);
     } else {
     	$typeArray = array();
     	$typeArray = explode(",", $typeArgs);
     	for($i = 0;$i < sizeof($typeArray); $i++) {
     		writeType($typeArray[$i], $name);
     	}
     }
     
     // add the template
     $widgetCSS = $resourceDir . $widgetPath . '/component.css';
     $style = $widgetDir .  "/component.css"; 
	 if (file_exists($widgetCSS) && !hasKey($pagestyles, $style)) {
       echo "<link type='text/css' rel='stylesheet' href='" . $style . "'></link>\n";
       array_push($pagestyles,$style);
     } 
     // get the template component
     $template = null; 
     if  (file_exists($resourceDir . $widgetPath . '/component.htm')) {
     	$template = file_get_contents($resourceDir . $widgetPath . '/component.htm');
     } else if (file_exists($resourceDir . $widgetPath . '/component.html')){
     	$template = file_get_contents($resourceDir . $widgetPath . '/component.html');
     } else {
     	echo "jMaki Error: Unable to locate template file";
     }
	 $lib = $widgetDir . "/component.js";
	 // write out the script for the component.js
	 if (!hasKey($pagelibs, $lib)){
		echo "<script type='text/javascript' src='" . $lib . "'></script>\n";
        array_push($pagelibs,$lib);
	 }
	 
     // now replace what needs to be replaced
     $template = preg_replace('/\$\{uuid\}/',  $uuid, $template);
     if (($value) && !strstr($value, '@{') ) {
     	 $template = preg_replace('/\$\{value\}/',  $value, $template);
     } else if (($value) && strstr($value, '@{') ) {
     	$template = preg_replace('/\$\{value\}/',  '', $template);
     }
     $template = preg_replace('/\$\{service\}/',  $service, $template);
     echo $template;
	 echo "\n";
	 // now serialize the arguments and pass them into the widget.
	 echo "<script type='text/javascript'>jmaki.addWidget({" . 
	 		  "uuid:" .  "\"" . $uuid . "\"," .
	 		  "name:" .  "\"" . $name . "\"," . 
	 		  "widgetDir:" .  "\"" . $widgetDir . "\"," ; 		  
    if ($service) {
		 echo "service: '" . $service . "',";
	 }
	 if (($value) && strstr($value, '{') && !strstr($value, '@{') ) {
		 echo "value: " . $value . ",";
	 } else if ($value) {
		 echo "value: \"" . $value . "\",";
     }
    if ($args) {
	     echo "args: " . $args . ",";
	}
	echo "script:" .  "\"" . $lib . "\"" . 
	          "});</script>\n";         
}

function hasKey($tarray, $key) {
   for($i = 0;$i < sizeof($tarray); $i++) {
       if ($tarray[$i] == $key) {
	       return true;
	    }
   }
   return false;  
}

function writeType($type,$name) {
  global $json, $contextRoot, $types, $pagelibs, $currentURI, $resourceDir, $widgetPath;
	$typeo = null;

	// check the widget to see if it has type information in the widget.json
	// it true all type information from the widget.config takes precedence.
	if (file_exists($resourceDir . $widgetPath . '/widget.json')){
		$jsons = new Services_JSON();
		$wjson = file_get_contents($resourceDir . $widgetPath . '/widget.json');
		$wcfg = $jsons->decode($wjson);
		if (property_exists($wcfg, 'config')) {
	       if (property_exists($wcfg->config->type, 'styles')) {       	
	           writeGlobalStyles($wcfg->config->type);
	       }
	       if (property_exists($wcfg->config->type, 'preload')) {
               echo "<script type='text/javascript'>" .  $wcfg->config->type->preload . "</script>\n";
     	   }
     	   if (property_exists($wcfg->config, 'type')) {
		   		writeGlobalScripts($wcfg->config->type, $wcfg, $contextRoot, $resourceDir .$widgetPath);
     	   }
	       if (property_exists($wcfg->config->type, 'postload')) {
               echo "<script type='text/javascript'>" .  $wcfg->config->type->postload . "</script>\n";
     	   }
     	   return;
	    }
	}

	// check for the full type
    for($i = 0;$i < sizeof($json->config->types); $i++) {	
          if ( $json->config->types[$i]->id == $name) {
	          $typeo =  $json->config->types[$i];
	          $type = $name;
	      }
    }	
	// find the widget type
    if ($typeo == null) {
	    // infer the type from the first namespace part of the widget
	    if ($type == null) {
	    	$type = strtok($name, ".");
	    }
	    for($i = 0;$i < sizeof($json->config->types); $i++) {		
          if ( $json->config->types[$i]->id == $type) {
       	
	          $typeo =  $json->config->types[$i];
	      }
        }
    }  
   /** process each  type
     write out global styles for a library
     first write out all pre-conditions for the scripts
     next write out the script elements
     finally call the post load
   **/
   if ($typeo != null && !hasKey($types, $type)) {
   	
	  // write out the external JavaScript library references (global)
     if (property_exists($typeo, 'styles')) {    	
     	 writeGlobalStyles($typeo, $json);
	 }
	 // render any pre-conditiouns
	 if (property_exists($typeo, 'preload')) {
         echo "<script type='text/javascript'>" .  $typeo->preload . "</script>\n";
     }

     if (property_exists($typeo, 'libs')) {
       // write out the external JavaScript library references (global)
	   writeGlobalScripts($typeo, $json, $contextRoot, null);  	
	 }
	 
	 if (property_exists($typeo, 'postload')) {
         echo "<script type='text/javascript'>" . $typeo->postload . "</script>\n";
     }
     // push type into the array to prevent it from being reloaded
     array_push($types, $type);
     }	
}

function generateUUID($name) {
	$counter = $_SESSION['uuid'] + 1;
	$_SESSION['uuid'] = $counter;
    return (preg_replace('/\./', '_', $name)   . '_' . $counter++);
}

function writeGlobalStyles($type) {
    global $contextRoot;
  		// write out the external JavaScript library references (global)
	    if (property_exists($type, 'styles')) {
		     for($i = 0;$i < sizeof($type->styles); $i++) {
			     echo "<link type='text/css' rel='stylesheet' href='" . $contextRoot . $type->styles[$i] . "'></link>\n";
	         }
		 }	
}

/*
 * This function writes out all the global scripts required by a widget.
 *
 */
function writeGlobalScripts($typeo, $cfg, $contextRoot, $widgetPath) {
	 global $pagelibs, $currentURI;
     // write out the external JavaScript library references (global)
     if (property_exists($typeo, 'libs')) {
		$apikey = null;
     	// check if there is an apikey
		if (property_exists($typeo, 'apikey')) {
		    $aKey = $typeo->apikey;
		    // search for api keys only if defined in the config.json
		    if (property_exists($cfg->config, 'apikeys')) {
		    	$globalApiKey= null;
			    for($i = 0;$i < sizeof($cfg->config->apikeys); $i++) {
			          if ($cfg->config->apikeys[$i]->id == $aKey) {
				          $globalApiKey =  $cfg->config->apikeys[$i];
				      }
			    }    
			    // check the key against the context root unless '*'
			    if ($globalApiKey != null) {
			    	$found = false;
			    	$lctx = $contextRoot . "/";
			    	for($ii = 0;!$found && $ii < sizeof($globalApiKey->keys); $ii++) {
                        $tkey = $globalApiKey->keys[$ii]->url;
                        $last = strlen($tkey) - 1;
						if ($tkey[$last] != "/" && $tkey[0] != "*") $tkey = $tkey . "/";					
			    		if ($tkey== "*") {
			    			$apikey = $globalApiKey->keys[$ii]->key;
			    			$found = true;
			    		} else if ($tkey == $currentURI){	    			
			    			$apikey = $globalApiKey->keys[$ii]->key;
			    			$found = true;		    			
			    		}
			    	}
			    }
			    
			}      	
		}
	    for($i = 0;$i < sizeof($typeo->libs); $i++) {
		     // TODO: create a second script array to prevent types
		     // with duplicate libraries from being reloaded.
		     $lib = $typeo->libs[$i];
		     // check if this an external link : TODO: This could do better matching
		     $isExternal = strstr($lib, 'http');
		     // if not external make sure the root is set correctly
		     if ($isExternal == null) {
		     	// if this script starts with a '/' and its from a widget.json
		     	// it will be relative to the widget.json location.
		     	if ($lib[0] != "/" && $widgetPath != null) {
					$lib = $widgetPath . '/' . $lib;
				} else {
			     	$lib = $contextRoot . $lib;
				}
		     }
			 if ($apikey != null) {
			 	$lib = $lib . $apikey;
			 }
			 if (!hasKey($pagelibs, $lib)){
		        echo "<script type='text/javascript' src='" . $lib . "'></script>\n";
		        array_push($pagelibs, $lib);
	        }
         }
    }
}
?>