<?php
  // we need this to parse JSON
  require_once 'Json.php';
  $xhpConfig = null;
  $JSONParser = new Services_JSON();

  $xhpConfigFile = file_get_contents('resources/xhp.json');
  $xhpConfig = $JSONParser->decode($xhpConfigFile );
   
  $id = null;
  if (array_key_exists('key',  $_GET)) $id = $_GET['key'];
  $params = null;
  if (array_key_exists('urlparams',  $_GET)) $params = $_GET['urlparams'];
  if ($id == null) {
      echo "XmlHttpProxy Error. The proxy requires a key parameter.";	
  } else {
	$service = null;
	// find the service type

    if ($id != null) {

	    for($i = 0;$i < sizeof($xhpConfig->xhp->services); $i++) {	

          if ($xhpConfig->xhp->services[$i]->id == $id) {

	          $service = $xhpConfig->xhp->services[$i];
	      }

        }

    }
	if ($service != null) {

		$xml = new DOMDocument;
		$serviceURL = $service->url;
		if (property_exists($service, 'apikey')) {
            $serviceURL = $serviceURL . "?" . $service->apikey . "&";
		} else {
            $serviceURL = $serviceURL . "?";
		}
		// add the parameters to the url
		if ($params != null) {
            $serviceURL = $serviceURL . $params . "&";
		} else if (property_exists($service, 'defaultURLParams')) {
            $serviceURL = $serviceURL . $service->defaultURLParams;
		}
		// go fetch the serivce
		$xml->load($serviceURL);
		// load the style sheet
		$xsl = new DOMDocument;		
		$xslName = "resources/xsl/" . $service->xslStyleSheet;

		$xsl->load($xslName);
		// Load and configure the transformer
		$proc = new XSLTProcessor;
		$proc->importStyleSheet($xsl);
	
		echo $proc->transformToXML($xml);
	} else {
		echo "XmlHttpProxy Error. There is not a service for the key '" . $id . "'";
	}
}
?>