
function testPublishRegExp(tcount, tid, verbose) {
    // clear the listeners
    jmaki.namespace('jmaki.config.glue');
    jmaki.config.glue.listeners = [];
    var results = 0;
    var target = document.getElementById(tid);
    var cStart = new Date();
    target.appendChild(document.createTextNode("Start " + cStart.getHours() + ":" + cStart.getMinutes() + ":" + cStart.getSeconds()));
    target.appendChild(document.createElement( "<br>"));
    for (var _i=0; _i < tcount; _i++)  {
        jmaki.addGlueListener(new RegExp("topic" + _i + "$"), function() {
            var _t = _i;
            if (verbose) {
                target.appendChild(document.createTextNode("Matched /topic" + _t ));
                target.appendChild(document.createElement( "<br>"));
            }
            results++;
        });
    }
    var start = new Date();
     if (verbose) target.appendChild(document.createTextNode("Topic Creation " + cStart.getHours() + ":" + cStart.getMinutes() + ":" + cStart.getSeconds()));
     if (verbose) target.appendChild(document.createElement( "<br>"));
     target.appendChild(document.createTextNode("Topic creation time " + (start - cStart) + "ms"));
     target.appendChild(document.createElement( "<br>"));
     // publish from ounter boundry backwards to 
     // make sure everything gets called
     for (var i= tcount + 1; i >= 0; i--)  {
         jmaki.publish("/topic" + i, {});
     }
     var stop = new Date();
      if (verbose) target.appendChild(document.createTextNode("Stop " + stop.getHours() + ":" + stop.getMinutes() + ":" + stop.getSeconds()));
      if (verbose) target.appendChild(document.createElement( "<br>"));
     target.appendChild(document.createTextNode("Regex processing time " + (stop - start) + "ms"));
     target.appendChild(document.createElement( "<br>"));
     target.appendChild(document.createTextNode("Messages passed " + results));
     target.appendChild(document.createElement( "<br>"));
     target.appendChild(document.createTextNode("Total time " + (stop - cStart) + "ms"));
     target.appendChild(document.createElement( "<br>"));     
}

function testPublishString(tcount, tid, verbose) {
    // clear the listeners
    jmaki.namespace('jmaki.config.glue');
    jmaki.config.glue.listeners = [];
    var results = 0;
    var target = document.getElementById(tid);
    var cStart = new Date();
    target.appendChild(document.createTextNode("Start " + cStart.getHours() + ":" + cStart.getMinutes() + ":" + cStart.getSeconds()));
    target.appendChild(document.createElement( "<br>"));
    for (var i=0; i < tcount; i++)  {
        jmaki.addGlueListener("/topic" + i, function() {
            if (verbose) {
                target.appendChild(document.createTextNode("Matched /topic" + i ));
                target.appendChild(document.createElement( "<br>"));
            }
            results++;
        });
    }
    var start = new Date();
    target.appendChild(document.createTextNode("Object Creation " + cStart.getHours() + ":" + cStart.getMinutes() + ":" + cStart.getSeconds()));
    target.appendChild(document.createElement( "<br>"));
     target.appendChild(document.createTextNode("Object creation time " + (start - cStart) + "ms"));
     target.appendChild(document.createElement( "<br>"));    
    // publish from ounter boundry backwards to 
    // make sure everything gets called
     for (var i= tcount + 1; i >= 0; i--)  {
         jmaki.publish("/topic" + i, {});
     }
     var stop = new Date();
     target.appendChild(document.createTextNode("Stop " + stop.getHours() + ":" + stop.getMinutes() + ":" + stop.getSeconds()));
     target.appendChild(document.createElement( "<br>"));
     target.appendChild(document.createTextNode("Regex processing time " + (stop - start) + "ms"));
     target.appendChild(document.createElement( "<br>"));
     target.appendChild(document.createTextNode("Messages passed " + results));
     target.appendChild(document.createElement( "<br>"));
     target.appendChild(document.createTextNode("Total time " + (stop - cStart) + "ms"));
     target.appendChild(document.createElement( "<br>"));     
}