/* Copyright 2005 Sun Microsystems, Inc. All rights reserved. You may not modify, use, reproduce, or distribute this software except in compliance with the terms of the License at: http://developer.sun.com/berkeley_license.html
 */

/*
 * ApplicationBean.java
 *
 * Created on June 16, 2005, 4:13 PM
 *
 * A bean containing a completion service and values to test the value bindings.
 *
 */
package com.sun.jmaki.dojo;

import java.text.SimpleDateFormat;
import java.util.Date;

import javax.faces.context.FacesContext;
import javax.servlet.http.HttpServletRequest;
import com.sun.jmaki.*;

public class ApplicationBean {

    private String message = "Edit Me Please!";
    private String country = "";
    private Date date = new Date();
    private Date time = new Date();
    private SimpleDateFormat f, t;

    public ApplicationBean() {
    }
    
    public String getMessage() {
        return message;
    }
    
    public void setMessage(String m) {
        this.message = m;
    }
    
    public String getDate() {
        if (f == null) {
            f = new SimpleDateFormat("MM/dd/yyyy");
        }
        return f.format(date);
    }
    
    public void setDate(String ds) {
        date = new Date(ds);
    }
    
    public String getTime() {
	if ( t == null) {
	    t = new SimpleDateFormat("HH:MM");
	}
	return t.format(time);
	
    }

    public void setTime (String t) {
        time = new Date(t);  
        System.out.println("time set to " + time);
    }
    
    public String getCountry () {
        return country;
    }
    
    public void setCountry(String country) {
        this.country = country;
    }
    
    private String[] countries =
        new String[] {
            "Canada", "France", "Uganda", "Ukraine", "United States of America", "United Kingdom",
            "Japan", "Korea", "Jamacia", "Thailand"
        };
   
   private String[] countryCodes =
        new String[] {
            "CA", "FR", "UG", "UR", "USA", "UK", "JP", "KR", "JA", "TH"
        };


   public void countryService(FacesContext context, AjaxResult result) {
       HttpServletRequest request = (HttpServletRequest)context.getExternalContext().getRequest();
       // get the command
       String command = request.getParameter("cmd");
       result.setResponseType(AjaxResult.JSON);
       if ("setValue".equals(command)) {
           String value = request.getParameter("value");
           setCountry(value);
           result.append("[message:'success']");
       } else {
           result.append("[");
           for (int loop=0; loop < countries.length; loop++){
               result.append("[\"" + countries[loop] + "\",\"" + countryCodes[loop] + "\" ]");
               if (loop < countries.length -1) result.append(",");
           }
           result.append("]");          
       }
   }
 
 }
