// define the namespaces
jmaki.namespace("jmaki.widgets.google.search");

jmaki.widgets.google.search.Widget = function(wargs) {
    // Create a search control
    var searchControl = new GSearchControl();
    
    var centerPoint =  'Santa Clara, CA';
    var defaultSearch = 'jmaki';
    var websearch = true;
    
    if (wargs.args) {
        if (wargs.args.defaultSearch) {
            defaultSearch = wargs.args.defaultSearch;
        }
        
        if (wargs.args.centerPoint) {
            centerPoint = wargs.args.centerPoint;
        }
        if (wargs.args.localSearch) {
            // Add in a full set of searchers
            var localSearch = new GlocalSearch();
            searchControl.addSearcher(localSearch);
            // Set the Local Search center point
            localSearch.setCenterPoint(centerPoint);                
        }
        if (wargs.args.websearch == false) {
            websearch = false;
        }
        if (wargs.args.videosearch) {
            searchControl.addSearcher(new GvideoSearch());
        }
        if (wargs.args.blogsearch) {
            searchControl.addSearcher(new GblogSearch());
        }
    }
    
    if (websearch) {
        var options = new GsearcherOptions();
        options.setExpandMode(GSearchControl.EXPAND_MODE_OPEN);
        searchControl.addSearcher(new GwebSearch(), options);            
    }
    
    
    // Tell the searcher to draw itself and tell it where to attach
    searchControl.draw(document.getElementById(wargs.uuid));
    
    // Execute an inital search
    searchControl.execute(defaultSearch);
}